import javafx.geometry.Point3D;

import javafx.geometry.BoundingBox;
import javafx.geometry.Bounds;

/**
 * AXeCh
 */
public class ARSpriteAsteroid extends ARSpriteT00 {

	/** ]x */
	private		double			s			= Math.random() * 4 + 2;

	/** xX */
	private		double			mx			= Math.random() * 0.1 - 0.05;

	/** xY */
	private		double			my			= Math.random() * 0.1 - 0.05;

	/** xZ */
	private		double			mz			= -Math.random() * 0.8 - 0.4;

	/**
	 * 
	 */
	public static void init() {

		try{
			ObjReader.init(ARSpriteAsteroid.class, "3d/Asteroid2.obj");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application ARApplication
	 * @param stage Xe[W
	 */
	public ARSpriteAsteroid(ARApplication application, int stage){

		// X[p[NXĂяo
		super(application);

		try{

			// p^[ݒ
			int pattern = 0;
			if(stage == 0){
				pattern = 1;
			}else if(stage % 3 == 0){
				pattern = 3;
			}else{
				pattern = stage % 3;
			}

			// x
			int lvl = stage / 3;

			// TCYݒ
			double size = 0;

			// p^[ʐݒ
			switch(pattern){

				// Xe[WPn
				case 1:

					// TCY
					size = 1.0;

					// uCN
					break;

				// Xe[WQn
				case 2:

					// TCY
					size = 0.6;

					// ]x
					s = Math.random() * 5 + 5;

					// x
					mx = Math.random() * 0.16 - 0.08;
					my = Math.random() * 0.16 - 0.08;
					mz = mz * (1 + lvl * 0.5);

					// uCN
					break;

				// Xe[WRn
				case 3:

					// TCY
					size = 2.0;

					// ]x
					s = Math.random() * 2 + 1;

					// x
					mx = Math.random() * 0.06 - 0.03;
					my = Math.random() * 0.06 - 0.03;
					mz = -Math.random() * 0.4 - 0.2;

					// uCN
					break;

				// ̑̏ꍇA
				default:

					// G[X[
					throw new IllegalStateException("pattern not found.");

			} // end switch p^[ʐݒ

			// Xݒ
			super.setTranslateX(Math.random() * 20 - 10);

			// Yݒ
			super.setTranslateY(Math.random() * 20 - 10);

			// Zݒ
			super.setTranslateZ(300);

			// IuWFNg
			ObjReader.create(this);

			// ]
			Point3D p = new Point3D(Math.random() - 0.5, Math.random() - 0.5, Math.random() - 0.5);

			// ]ݒ
			super.setRotationAxis(p);

			// g^k
			super.setScaleX(size);
			super.setScaleY(size);
			super.setScaleZ(size);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end ARSpriteAsteroid

	/**
	 * s
	 */
	public void run(){

		// W擾
		double x = super.getTranslateX();
		double y = super.getTranslateY();
		double z = super.getTranslateZ();

		// WZ
		x = x + mx;
		y = y + my;
		z = z + mz;

		// ʂ̊OɂłꍇA
		if(z < 10){
			// 폜
			super.remove();
		}

		// ړ
		super.setTranslateX(x);
		super.setTranslateY(y);
		super.setTranslateZ(z);

		// ]
		super.setRotate(getRotate() + this.s);

		//
		// 蔻
		//

		// yƂē蔻肪KvȏꍇA
		if(z < 12){

			// E擾
			Bounds boundsThis = this.getBoundsInParent();

			// 蔻肪̂ŁAɂ߂ɂ
			// BoundśAprotectedŐłȂ̂ŁABoundingBoxŐ
			boundsThis = new BoundingBox(
				boundsThis.getMinX() + boundsThis.getWidth() * 0.25,
				boundsThis.getMinY() + boundsThis.getHeight() * 0.25,
				boundsThis.getMinZ(),
				boundsThis.getWidth() * 0.5,
				boundsThis.getHeight() * 0.5,
				boundsThis.getDepth()
			);

			// @擾
			ARSpriteShip spriteShip = application.getARSpriteShip();

			// @擾łȂꍇA
			if(spriteShip == null){
				// ^[ 
				return;
			}

			// E擾
			Bounds boundsShip = spriteShip.getBoundsInParent();

			// 蔻肪̂ŁAɂ߂ɂ
			boundsShip = new BoundingBox(
				boundsShip.getMinX() + boundsShip.getWidth() * 0.25,
				boundsShip.getMinY() + boundsShip.getHeight() * 0.25,
				boundsShip.getMinZ(),
				boundsShip.getWidth() * 0.5,
				boundsShip.getHeight() * 0.5,
				boundsShip.getDepth()
			);

			// ĂꍇA
			if(boundsThis.intersects(boundsShip)){

				// G ^ NbV ł͂ȂꍇA
				if(!spriteShip.isMuteki() && !spriteShip.isClash()){

					// @NbV
					application.clash();

				}

			} // end if Ăꍇ

		} // end if yƂē蔻肪Kvȏꍇ

	} // end run

}
